/**
 * csv-split-easy
 * Splits the CSV string into array of arrays, each representing a row of columns
 * Version: 3.0.37
 * Author: Roy Revelt, Codsen Ltd
 * License: MIT
 * Homepage: https://gitlab.com/codsen/codsen/tree/master/packages/csv-split-easy
 */

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).csvSplitEasy=t()}(this,(function(){"use strict";function e(t){return(e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(t)}var t=function(e,t){if(t){if("object"!=typeof t)throw new TypeError(String(t)+" is not an object. Expected an object that has boolean `includeZero` property.");if("includeZero"in t){if("boolean"!=typeof t.includeZero)throw new TypeError(String(t.includeZero)+" is neither true nor false. `includeZero` option must be a Boolean value.");if(t.includeZero&&0===e)return!0}}return Number.isSafeInteger(e)&&e>=1},r=function(e,t){if("string"!=typeof e)return!1;if(t&&"includeZero"in t){if("boolean"!=typeof t.includeZero)throw new TypeError(String(t.includeZero)+" is neither true nor false. `includeZero` option must be a Boolean value.");if(t.includeZero)return/^(-?0|[1-9]\d*)(\.0+)?$/.test(e)}return/^[1-9]\d*(\.0+)?$/.test(e)};const n=Array.isArray;function o(e,r){if(!n(e))throw new TypeError(`ranges-sort: [THROW_ID_01] Input must be an array, consisting of range arrays! Currently its type is: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(0===e.length)return e;const o=Object.assign({},{strictlyTwoElementsInRangeArrays:!1,progressFn:null},r);let i,s;if(o.strictlyTwoElementsInRangeArrays&&!e.every((e,t)=>2===e.length||(i=t,s=e.length,!1)))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) has not two but ${s} elements!`);if(!e.every((e,r)=>!(!t(e[0],{includeZero:!0})||!t(e[1],{includeZero:!0}))||(i=r,!1)))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) does not consist of only natural numbers!`);const a=e.length*e.length;let u=0;return Array.from(e).sort((e,t)=>(o.progressFn&&(u++,o.progressFn(Math.floor(100*u/a))),e[0]===t[0]?e[1]<t[1]?-1:e[1]>t[1]?1:0:e[0]<t[0]?-1:1))}var i="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function s(e,t){return e(t={exports:{}},t.exports),t.exports}var a=s((function(e,t){var r=200,n="__lodash_hash_undefined__",o=9007199254740991,s="[object Arguments]",a="[object Boolean]",u="[object Date]",c="[object Function]",f="[object GeneratorFunction]",l="[object Map]",p="[object Number]",h="[object Object]",y="[object RegExp]",g="[object Set]",d="[object String]",m="[object Symbol]",b="[object ArrayBuffer]",v="[object DataView]",_="[object Float32Array]",w="[object Float64Array]",j="[object Int8Array]",O="[object Int16Array]",T="[object Int32Array]",S="[object Uint8Array]",$="[object Uint8ClampedArray]",N="[object Uint16Array]",E="[object Uint32Array]",A=/\w*$/,I=/^\[object .+?Constructor\]$/,k=/^(?:0|[1-9]\d*)$/,R={};R[s]=R["[object Array]"]=R[b]=R[v]=R[a]=R[u]=R[_]=R[w]=R[j]=R[O]=R[T]=R[l]=R[p]=R[h]=R[y]=R[g]=R[d]=R[m]=R[S]=R[$]=R[N]=R[E]=!0,R["[object Error]"]=R[c]=R["[object WeakMap]"]=!1;var D="object"==typeof i&&i&&i.Object===Object&&i,F="object"==typeof self&&self&&self.Object===Object&&self,P=D||F||Function("return this")(),W=t&&!t.nodeType&&t,x=W&&e&&!e.nodeType&&e,H=x&&x.exports===W;function M(e,t){return e.set(t[0],t[1]),e}function J(e,t){return e.add(t),e}function C(e,t,r,n){var o=-1,i=e?e.length:0;for(n&&i&&(r=e[++o]);++o<i;)r=t(r,e[o],o,e);return r}function K(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(e){}return t}function L(e){var t=-1,r=Array(e.size);return e.forEach((function(e,n){r[++t]=[n,e]})),r}function Z(e,t){return function(r){return e(t(r))}}function q(e){var t=-1,r=Array(e.size);return e.forEach((function(e){r[++t]=e})),r}var U,V=Array.prototype,B=Function.prototype,z=Object.prototype,G=P["__core-js_shared__"],Q=(U=/[^.]+$/.exec(G&&G.keys&&G.keys.IE_PROTO||""))?"Symbol(src)_1."+U:"",X=B.toString,Y=z.hasOwnProperty,ee=z.toString,te=RegExp("^"+X.call(Y).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),re=H?P.Buffer:void 0,ne=P.Symbol,oe=P.Uint8Array,ie=Z(Object.getPrototypeOf,Object),se=Object.create,ae=z.propertyIsEnumerable,ue=V.splice,ce=Object.getOwnPropertySymbols,fe=re?re.isBuffer:void 0,le=Z(Object.keys,Object),pe=xe(P,"DataView"),he=xe(P,"Map"),ye=xe(P,"Promise"),ge=xe(P,"Set"),de=xe(P,"WeakMap"),me=xe(Object,"create"),be=Ke(pe),ve=Ke(he),_e=Ke(ye),we=Ke(ge),je=Ke(de),Oe=ne?ne.prototype:void 0,Te=Oe?Oe.valueOf:void 0;function Se(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function $e(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Ne(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Ee(e){this.__data__=new $e(e)}function Ae(e,t){var r=Ze(e)||function(e){return function(e){return function(e){return!!e&&"object"==typeof e}(e)&&qe(e)}(e)&&Y.call(e,"callee")&&(!ae.call(e,"callee")||ee.call(e)==s)}(e)?function(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}(e.length,String):[],n=r.length,o=!!n;for(var i in e)!t&&!Y.call(e,i)||o&&("length"==i||Je(i,n))||r.push(i);return r}function Ie(e,t,r){var n=e[t];Y.call(e,t)&&Le(n,r)&&(void 0!==r||t in e)||(e[t]=r)}function ke(e,t){for(var r=e.length;r--;)if(Le(e[r][0],t))return r;return-1}function Re(e,t,r,n,o,i,I){var k;if(n&&(k=i?n(e,o,i,I):n(e)),void 0!==k)return k;if(!Be(e))return e;var D=Ze(e);if(D){if(k=function(e){var t=e.length,r=e.constructor(t);t&&"string"==typeof e[0]&&Y.call(e,"index")&&(r.index=e.index,r.input=e.input);return r}(e),!t)return function(e,t){var r=-1,n=e.length;t||(t=Array(n));for(;++r<n;)t[r]=e[r];return t}(e,k)}else{var F=Me(e),P=F==c||F==f;if(Ue(e))return function(e,t){if(t)return e.slice();var r=new e.constructor(e.length);return e.copy(r),r}(e,t);if(F==h||F==s||P&&!i){if(K(e))return i?e:{};if(k=function(e){return"function"!=typeof e.constructor||Ce(e)?{}:(t=ie(e),Be(t)?se(t):{});var t}(P?{}:e),!t)return function(e,t){return Pe(e,He(e),t)}(e,function(e,t){return e&&Pe(t,ze(t),e)}(k,e))}else{if(!R[F])return i?e:{};k=function(e,t,r,n){var o=e.constructor;switch(t){case b:return Fe(e);case a:case u:return new o(+e);case v:return function(e,t){var r=t?Fe(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}(e,n);case _:case w:case j:case O:case T:case S:case $:case N:case E:return function(e,t){var r=t?Fe(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}(e,n);case l:return function(e,t,r){return C(t?r(L(e),!0):L(e),M,new e.constructor)}(e,n,r);case p:case d:return new o(e);case y:return(c=new(s=e).constructor(s.source,A.exec(s))).lastIndex=s.lastIndex,c;case g:return function(e,t,r){return C(t?r(q(e),!0):q(e),J,new e.constructor)}(e,n,r);case m:return i=e,Te?Object(Te.call(i)):{}}var i;var s,c}(e,F,Re,t)}}I||(I=new Ee);var W=I.get(e);if(W)return W;if(I.set(e,k),!D)var x=r?function(e){return function(e,t,r){var n=t(e);return Ze(e)?n:function(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}(n,r(e))}(e,ze,He)}(e):ze(e);return function(e,t){for(var r=-1,n=e?e.length:0;++r<n&&!1!==t(e[r],r,e););}(x||e,(function(o,i){x&&(o=e[i=o]),Ie(k,i,Re(o,t,r,n,i,e,I))})),k}function De(e){return!(!Be(e)||(t=e,Q&&Q in t))&&(Ve(e)||K(e)?te:I).test(Ke(e));var t}function Fe(e){var t=new e.constructor(e.byteLength);return new oe(t).set(new oe(e)),t}function Pe(e,t,r,n){r||(r={});for(var o=-1,i=t.length;++o<i;){var s=t[o],a=n?n(r[s],e[s],s,r,e):void 0;Ie(r,s,void 0===a?e[s]:a)}return r}function We(e,t){var r,n,o=e.__data__;return("string"==(n=typeof(r=t))||"number"==n||"symbol"==n||"boolean"==n?"__proto__"!==r:null===r)?o["string"==typeof t?"string":"hash"]:o.map}function xe(e,t){var r=function(e,t){return null==e?void 0:e[t]}(e,t);return De(r)?r:void 0}Se.prototype.clear=function(){this.__data__=me?me(null):{}},Se.prototype.delete=function(e){return this.has(e)&&delete this.__data__[e]},Se.prototype.get=function(e){var t=this.__data__;if(me){var r=t[e];return r===n?void 0:r}return Y.call(t,e)?t[e]:void 0},Se.prototype.has=function(e){var t=this.__data__;return me?void 0!==t[e]:Y.call(t,e)},Se.prototype.set=function(e,t){return this.__data__[e]=me&&void 0===t?n:t,this},$e.prototype.clear=function(){this.__data__=[]},$e.prototype.delete=function(e){var t=this.__data__,r=ke(t,e);return!(r<0)&&(r==t.length-1?t.pop():ue.call(t,r,1),!0)},$e.prototype.get=function(e){var t=this.__data__,r=ke(t,e);return r<0?void 0:t[r][1]},$e.prototype.has=function(e){return ke(this.__data__,e)>-1},$e.prototype.set=function(e,t){var r=this.__data__,n=ke(r,e);return n<0?r.push([e,t]):r[n][1]=t,this},Ne.prototype.clear=function(){this.__data__={hash:new Se,map:new(he||$e),string:new Se}},Ne.prototype.delete=function(e){return We(this,e).delete(e)},Ne.prototype.get=function(e){return We(this,e).get(e)},Ne.prototype.has=function(e){return We(this,e).has(e)},Ne.prototype.set=function(e,t){return We(this,e).set(e,t),this},Ee.prototype.clear=function(){this.__data__=new $e},Ee.prototype.delete=function(e){return this.__data__.delete(e)},Ee.prototype.get=function(e){return this.__data__.get(e)},Ee.prototype.has=function(e){return this.__data__.has(e)},Ee.prototype.set=function(e,t){var n=this.__data__;if(n instanceof $e){var o=n.__data__;if(!he||o.length<r-1)return o.push([e,t]),this;n=this.__data__=new Ne(o)}return n.set(e,t),this};var He=ce?Z(ce,Object):function(){return[]},Me=function(e){return ee.call(e)};function Je(e,t){return!!(t=null==t?o:t)&&("number"==typeof e||k.test(e))&&e>-1&&e%1==0&&e<t}function Ce(e){var t=e&&e.constructor;return e===("function"==typeof t&&t.prototype||z)}function Ke(e){if(null!=e){try{return X.call(e)}catch(e){}try{return e+""}catch(e){}}return""}function Le(e,t){return e===t||e!=e&&t!=t}(pe&&Me(new pe(new ArrayBuffer(1)))!=v||he&&Me(new he)!=l||ye&&"[object Promise]"!=Me(ye.resolve())||ge&&Me(new ge)!=g||de&&"[object WeakMap]"!=Me(new de))&&(Me=function(e){var t=ee.call(e),r=t==h?e.constructor:void 0,n=r?Ke(r):void 0;if(n)switch(n){case be:return v;case ve:return l;case _e:return"[object Promise]";case we:return g;case je:return"[object WeakMap]"}return t});var Ze=Array.isArray;function qe(e){return null!=e&&function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=o}(e.length)&&!Ve(e)}var Ue=fe||function(){return!1};function Ve(e){var t=Be(e)?ee.call(e):"";return t==c||t==f}function Be(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function ze(e){return qe(e)?Ae(e):function(e){if(!Ce(e))return le(e);var t=[];for(var r in Object(e))Y.call(e,r)&&"constructor"!=r&&t.push(r);return t}(e)}e.exports=function(e){return Re(e,!0,!0)}})),u="[object Object]";var c,f,l=Function.prototype,p=Object.prototype,h=l.toString,y=p.hasOwnProperty,g=h.call(Object),d=p.toString,m=(c=Object.getPrototypeOf,f=Object,function(e){return c(f(e))});var b=function(e){if(!function(e){return!!e&&"object"==typeof e}(e)||d.call(e)!=u||function(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(e){}return t}(e))return!1;var t=m(e);if(null===t)return!0;var r=y.call(t,"constructor")&&t.constructor;return"function"==typeof r&&r instanceof r&&h.call(r)==g};function v(e,t){function r(e){return"string"==typeof e}if(!Array.isArray(e))return e;const n={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};let i;if(t){if(!b(t))throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:\n${JSON.stringify(t,null,4)} (type ${typeof t})`);if((i=Object.assign({},n,t)).progressFn&&b(i.progressFn)&&!Object.keys(i.progressFn).length)i.progressFn=null;else if(i.progressFn&&"function"!=typeof i.progressFn)throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof i.progressFn}", equal to ${JSON.stringify(i.progressFn,null,4)}`);if(i.mergeType&&1!==i.mergeType&&2!==i.mergeType)if(r(i.mergeType)&&"1"===i.mergeType.trim())i.mergeType=1;else{if(!r(i.mergeType)||"2"!==i.mergeType.trim())throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof i.mergeType}", equal to ${JSON.stringify(i.mergeType,null,4)}`);i.mergeType=2}if("boolean"!=typeof i.joinRangesThatTouchEdges)throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof i.joinRangesThatTouchEdges}", equal to ${JSON.stringify(i.joinRangesThatTouchEdges,null,4)}`)}else i=a(n);const s=a(e).filter(e=>void 0!==e[2]||e[0]!==e[1]);let u,c,f;const l=(u=i.progressFn?o(s,{progressFn:e=>{(f=Math.floor(e/5))!==c&&(c=f,i.progressFn(f))}}):o(s)).length-1;for(let e=l;e>0;e--)i.progressFn&&(f=Math.floor(78*(1-e/l))+21)!==c&&f>c&&(c=f,i.progressFn(f)),(u[e][0]<=u[e-1][0]||!i.joinRangesThatTouchEdges&&u[e][0]<u[e-1][1]||i.joinRangesThatTouchEdges&&u[e][0]<=u[e-1][1])&&(u[e-1][0]=Math.min(u[e][0],u[e-1][0]),u[e-1][1]=Math.max(u[e][1],u[e-1][1]),void 0!==u[e][2]&&(u[e-1][0]>=u[e][0]||u[e-1][1]<=u[e][1])&&null!==u[e-1][2]&&(null===u[e][2]&&null!==u[e-1][2]?u[e-1][2]=null:void 0!==u[e-1][2]?2===i.mergeType&&u[e-1][0]===u[e][0]?u[e-1][2]=u[e][2]:u[e-1][2]+=u[e][2]:u[e-1][2]=u[e][2]),u.splice(e,1),e=u.length);return u}const _=Array.isArray;const w=" ";function j(e,t=!0,r){if(!(r.trim().length||e.length&&"\n"!==r&&r!==w&&" "===(t?e[e.length-1]:e[0])||e.length&&"\n"===(t?e[e.length-1]:e[0])&&"\n"!==r&&r!==w))if(t){if(("\n"===r||r===w)&&e.length&&" "===e[e.length-1])for(;e.length&&" "===e[e.length-1];)e.pop();e.push(r===w||"\n"===r?r:" ")}else{if(("\n"===r||r===w)&&e.length&&" "===e[0])for(;e.length&&" "===e[0];)e.shift();e.unshift(r===w||"\n"===r?r:" ")}}function O(e,t){if("string"==typeof e&&e.length){let r,n,o=!1;if(e.includes("\r\n")&&(o=!0),r=t&&"number"==typeof t?t:1,""===e.trim()){const t=[];for(n=r,Array.from(e).forEach(e=>{("\n"!==e||n)&&("\n"===e&&n--,j(t,!0,e))});t.length>1&&" "===t[t.length-1];)t.pop();return t.join("")}const i=[];if(n=r,""===e[0].trim())for(let t=0,r=e.length;t<r&&0===e[t].trim().length;t++)("\n"!==e[t]||n)&&("\n"===e[t]&&n--,j(i,!0,e[t]));const s=[];if(n=r,""===e.slice(-1).trim())for(let t=e.length;t--&&0===e[t].trim().length;)("\n"!==e[t]||n)&&("\n"===e[t]&&n--,j(s,!1,e[t]));return o?`${i.join("")}${e.trim()}${s.join("")}`.replace(/\n/g,"\r\n"):i.join("")+e.trim()+s.join("")}return e}function T(e){return null!=e}const S=Array.isArray,$=Number.isInteger;function N(e){return"string"==typeof e}function E(e){return r(e,{includeZero:!0})?parseInt(e,10):e}class A{constructor(e){const t=Object.assign({},{limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},e);if(t.mergeType&&1!==t.mergeType&&2!==t.mergeType)if(N(t.mergeType)&&"1"===t.mergeType.trim())t.mergeType=1;else{if(!N(t.mergeType)||"2"!==t.mergeType.trim())throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof t.mergeType}", equal to ${JSON.stringify(t.mergeType,null,4)}`);t.mergeType=2}this.opts=t}add(e,n,o,...i){if(i.length>0)throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_03] Please don't overload the add() method. From the 4th input argument onwards we see these redundant arguments: ${JSON.stringify(i,null,4)}`);if(!T(e)&&!T(n))return;if(T(e)&&!T(n)){if(S(e)){if(e.length){if(e.some(e=>S(e)))return void e.forEach(e=>{S(e)&&this.add(...e)});e.length>1&&$(E(e[0]))&&$(E(e[1]))&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(n,null,0)})`)}if(!T(e)&&T(n))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(n,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);const s=r(e,{includeZero:!0})?parseInt(e,10):e,a=r(n,{includeZero:!0})?parseInt(n,10):n;if($(o)&&(o=String(o)),!t(s,{includeZero:!0})||!t(a,{includeZero:!0}))throw t(s,{includeZero:!0})?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof a}" equal to: ${JSON.stringify(a,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof s}" equal to: ${JSON.stringify(s,null,4)}`);if(T(o)&&!N(o)&&!$(o))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof o}, equal to:\n${JSON.stringify(o,null,4)}`);if(T(this.slices)&&S(this.last())&&s===this.last()[1]){if(this.last()[1]=a,this.last()[2],null!==this.last()[2]&&T(o)){let e=!(T(this.last()[2])&&this.last()[2].length>0)||this.opts&&this.opts.mergeType&&1!==this.opts.mergeType?o:this.last()[2]+o;this.opts.limitToBeAddedWhitespace&&(e=O(e,this.opts.limitLinebreaksCount)),N(e)&&!e.length||(this.last()[2]=e)}}else{this.slices||(this.slices=[]);const e=void 0===o||N(o)&&!o.length?[s,a]:[s,a,this.opts.limitToBeAddedWhitespace?O(o,this.opts.limitLinebreaksCount):o];this.slices.push(e)}}push(e,t,r,...n){this.add(e,t,r,...n)}current(){return null!=this.slices?(this.slices=v(this.slices,{mergeType:this.opts.mergeType}),this.opts.limitToBeAddedWhitespace?this.slices.map(e=>T(e[2])?[e[0],e[1],O(e[2],this.opts.limitLinebreaksCount)]:e):this.slices):null}wipe(){this.slices=void 0}replace(e){if(S(e)&&e.length){if(!S(e[0])||!$(e[0][0]))throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);this.slices=a(e)}else this.slices=void 0}last(){return void 0!==this.slices&&Array.isArray(this.slices)?this.slices[this.slices.length-1]:null}}var I=s((function(e,t){var r,n,o,s,a,u,c,f,l,p,h,y,g,d,m,b,v,_,w,j;e.exports=(r="function"==typeof Promise,n="object"==typeof self?self:i,o="undefined"!=typeof Symbol,s="undefined"!=typeof Map,a="undefined"!=typeof Set,u="undefined"!=typeof WeakMap,c="undefined"!=typeof WeakSet,f="undefined"!=typeof DataView,l=o&&void 0!==Symbol.iterator,p=o&&void 0!==Symbol.toStringTag,h=a&&"function"==typeof Set.prototype.entries,y=s&&"function"==typeof Map.prototype.entries,g=h&&Object.getPrototypeOf((new Set).entries()),d=y&&Object.getPrototypeOf((new Map).entries()),m=l&&"function"==typeof Array.prototype[Symbol.iterator],b=m&&Object.getPrototypeOf([][Symbol.iterator]()),v=l&&"function"==typeof String.prototype[Symbol.iterator],_=v&&Object.getPrototypeOf(""[Symbol.iterator]()),w=8,j=-1,function(e){var t=typeof e;if("object"!==t)return t;if(null===e)return"null";if(e===n)return"global";if(Array.isArray(e)&&(!1===p||!(Symbol.toStringTag in e)))return"Array";if("object"==typeof window&&null!==window){if("object"==typeof window.location&&e===window.location)return"Location";if("object"==typeof window.document&&e===window.document)return"Document";if("object"==typeof window.navigator){if("object"==typeof window.navigator.mimeTypes&&e===window.navigator.mimeTypes)return"MimeTypeArray";if("object"==typeof window.navigator.plugins&&e===window.navigator.plugins)return"PluginArray"}if(("function"==typeof window.HTMLElement||"object"==typeof window.HTMLElement)&&e instanceof window.HTMLElement){if("BLOCKQUOTE"===e.tagName)return"HTMLQuoteElement";if("TD"===e.tagName)return"HTMLTableDataCellElement";if("TH"===e.tagName)return"HTMLTableHeaderCellElement"}}var o=p&&e[Symbol.toStringTag];if("string"==typeof o)return o;var i=Object.getPrototypeOf(e);return i===RegExp.prototype?"RegExp":i===Date.prototype?"Date":r&&i===Promise.prototype?"Promise":a&&i===Set.prototype?"Set":s&&i===Map.prototype?"Map":c&&i===WeakSet.prototype?"WeakSet":u&&i===WeakMap.prototype?"WeakMap":f&&i===DataView.prototype?"DataView":s&&i===d?"Map Iterator":a&&i===g?"Set Iterator":m&&i===b?"Array Iterator":v&&i===_?"String Iterator":null===i?"Object":Object.prototype.toString.call(e).slice(w,j)})}));function k(e,t,r){if(t!=t)return function(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}(e,D,r);for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}function R(e,t,r,n){for(var o=r-1,i=e.length;++o<i;)if(n(e[o],t))return o;return-1}function D(e){return e!=e}var F=Array.prototype.splice;function P(e,t,r,n){var o=n?R:k,i=-1,s=t.length,a=e;for(e===t&&(t=function(e,t){var r=-1,n=e.length;t||(t=Array(n));for(;++r<n;)t[r]=e[r];return t}(t)),r&&(a=function(e,t){for(var r=-1,n=e?e.length:0,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}(e,function(e){return function(t){return e(t)}}(r)));++i<s;)for(var u=0,c=t[i],f=r?r(c):c;(u=o(a,f,u,n))>-1;)a!==e&&F.call(a,u,1),F.call(e,u,1);return e}var W=function(e,t){return e&&e.length&&t&&t.length?P(e,t):e};const x=Array.isArray;function H(e){return"string"==typeof e&&e.length>0&&"."===e[0]?e.slice(1):e}function M(e,t){return function e(t,r,n){const o=a(t);let i,s,u,c,f;if((n=Object.assign({depth:-1,path:""},n)).depth+=1,x(o))for(i=0,s=o.length;i<s;i++){const t=`${n.path}.${i}`;void 0!==o[i]?(n.parent=a(o),n.parentType="array",u=e(r(o[i],void 0,Object.assign({},n,{path:H(t)})),r,Object.assign({},n,{path:H(t)})),Number.isNaN(u)&&i<o.length?(o.splice(i,1),i-=1):o[i]=u):o.splice(i,1)}else if(b(o))for(i=0,s=(c=Object.keys(o)).length;i<s;i++){f=c[i];const t=`${n.path}.${f}`;0===n.depth&&null!=f&&(n.topmostKey=f),n.parent=a(o),n.parentType="object",u=e(r(f,o[f],Object.assign({},n,{path:H(t)})),r,Object.assign({},n,{path:H(t)})),Number.isNaN(u)?delete o[f]:o[f]=u}return o}(e,t,{})}var J="__lodash_hash_undefined__",C=9007199254740991,K="[object Function]",L="[object GeneratorFunction]",Z=/^\[object .+?Constructor\]$/,q="object"==typeof i&&i&&i.Object===Object&&i,U="object"==typeof self&&self&&self.Object===Object&&self,V=q||U||Function("return this")();function B(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)}function z(e,t){return!!(e?e.length:0)&&function(e,t,r){if(t!=t)return function(e,t,r,n){var o=e.length,i=r+(n?1:-1);for(;n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}(e,X,r);var n=r-1,o=e.length;for(;++n<o;)if(e[n]===t)return n;return-1}(e,t,0)>-1}function G(e,t,r){for(var n=-1,o=e?e.length:0;++n<o;)if(r(t,e[n]))return!0;return!1}function Q(e,t){for(var r=-1,n=e?e.length:0,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}function X(e){return e!=e}function Y(e){return function(t){return e(t)}}function ee(e,t){return e.has(t)}var te,re=Array.prototype,ne=Function.prototype,oe=Object.prototype,ie=V["__core-js_shared__"],se=(te=/[^.]+$/.exec(ie&&ie.keys&&ie.keys.IE_PROTO||""))?"Symbol(src)_1."+te:"",ae=ne.toString,ue=oe.hasOwnProperty,ce=oe.toString,fe=RegExp("^"+ae.call(ue).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),le=re.splice,pe=Math.max,he=Math.min,ye=Te(V,"Map"),ge=Te(Object,"create");function de(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function me(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function be(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function ve(e){var t=-1,r=e?e.length:0;for(this.__data__=new be;++t<r;)this.add(e[t])}function _e(e,t){for(var r,n,o=e.length;o--;)if((r=e[o][0])===(n=t)||r!=r&&n!=n)return o;return-1}function we(e){return!(!$e(e)||function(e){return!!se&&se in e}(e))&&(Se(e)||function(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(e){}return t}(e)?fe:Z).test(function(e){if(null!=e){try{return ae.call(e)}catch(e){}try{return e+""}catch(e){}}return""}(e))}function je(e){return function(e){return function(e){return!!e&&"object"==typeof e}(e)&&function(e){return null!=e&&function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=C}(e.length)&&!Se(e)}(e)}(e)?e:[]}function Oe(e,t){var r,n,o=e.__data__;return("string"==(n=typeof(r=t))||"number"==n||"symbol"==n||"boolean"==n?"__proto__"!==r:null===r)?o["string"==typeof t?"string":"hash"]:o.map}function Te(e,t){var r=function(e,t){return null==e?void 0:e[t]}(e,t);return we(r)?r:void 0}function Se(e){var t=$e(e)?ce.call(e):"";return t==K||t==L}function $e(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}de.prototype.clear=function(){this.__data__=ge?ge(null):{}},de.prototype.delete=function(e){return this.has(e)&&delete this.__data__[e]},de.prototype.get=function(e){var t=this.__data__;if(ge){var r=t[e];return r===J?void 0:r}return ue.call(t,e)?t[e]:void 0},de.prototype.has=function(e){var t=this.__data__;return ge?void 0!==t[e]:ue.call(t,e)},de.prototype.set=function(e,t){return this.__data__[e]=ge&&void 0===t?J:t,this},me.prototype.clear=function(){this.__data__=[]},me.prototype.delete=function(e){var t=this.__data__,r=_e(t,e);return!(r<0)&&(r==t.length-1?t.pop():le.call(t,r,1),!0)},me.prototype.get=function(e){var t=this.__data__,r=_e(t,e);return r<0?void 0:t[r][1]},me.prototype.has=function(e){return _e(this.__data__,e)>-1},me.prototype.set=function(e,t){var r=this.__data__,n=_e(r,e);return n<0?r.push([e,t]):r[n][1]=t,this},be.prototype.clear=function(){this.__data__={hash:new de,map:new(ye||me),string:new de}},be.prototype.delete=function(e){return Oe(this,e).delete(e)},be.prototype.get=function(e){return Oe(this,e).get(e)},be.prototype.has=function(e){return Oe(this,e).has(e)},be.prototype.set=function(e,t){return Oe(this,e).set(e,t),this},ve.prototype.add=ve.prototype.push=function(e){return this.__data__.set(e,J),this},ve.prototype.has=function(e){return this.__data__.has(e)};var Ne=function(e,t){return t=pe(void 0===t?e.length-1:t,0),function(){for(var r=arguments,n=-1,o=pe(r.length-t,0),i=Array(o);++n<o;)i[n]=r[t+n];n=-1;for(var s=Array(t+1);++n<t;)s[n]=r[n];return s[t]=i,B(e,this,s)}}((function(e){var t=Q(e,je);return t.length&&t[0]===e[0]?function(e,t,r){for(var n=r?G:z,o=e[0].length,i=e.length,s=i,a=Array(i),u=1/0,c=[];s--;){var f=e[s];s&&t&&(f=Q(f,Y(t))),u=he(f.length,u),a[s]=!r&&(t||o>=120&&f.length>=120)?new ve(s&&f):void 0}f=e[0];var l=-1,p=a[0];e:for(;++l<o&&c.length<u;){var h=f[l],y=t?t(h):h;if(h=r||0!==h?h:0,!(p?ee(p,y):n(c,y,r))){for(s=i;--s;){var g=a[s];if(!(g?ee(g,y):n(e[s],y,r)))continue e}p&&p.push(y),c.push(h)}}return c}(t):[]}));function Ee(e){return"string"==typeof e?e.length>0?[e]:[]:e}var Ae=s((function(e){e.exports=function(){var e=Object.prototype.toString;function t(e,t){return null!=e&&Object.prototype.hasOwnProperty.call(e,t)}function r(e){if(!e)return!0;if(o(e)&&0===e.length)return!0;if("string"!=typeof e){for(var r in e)if(t(e,r))return!1;return!0}return!1}function n(t){return e.call(t)}var o=Array.isArray||function(t){return"[object Array]"===e.call(t)};function i(e){var t=parseInt(e);return t.toString()===e?t:e}function s(e){e=e||{};var s=function(e){return Object.keys(s).reduce((function(t,r){return"create"===r?t:("function"==typeof s[r]&&(t[r]=s[r].bind(s,e)),t)}),{})};function a(r,n){return e.includeInheritedProps||"number"==typeof n&&Array.isArray(r)||t(r,n)}function u(e,t){if(a(e,t))return e[t]}function c(e,t,r,n){if("number"==typeof t&&(t=[t]),!t||0===t.length)return e;if("string"==typeof t)return c(e,t.split(".").map(i),r,n);var o=t[0],s=u(e,o);return 1===t.length?(void 0!==s&&n||(e[o]=r),s):(void 0===s&&("number"==typeof t[1]?e[o]=[]:e[o]={}),c(e[o],t.slice(1),r,n))}return s.has=function(r,n){if("number"==typeof n?n=[n]:"string"==typeof n&&(n=n.split(".")),!n||0===n.length)return!!r;for(var s=0;s<n.length;s++){var a=i(n[s]);if(!("number"==typeof a&&o(r)&&a<r.length||(e.includeInheritedProps?a in Object(r):t(r,a))))return!1;r=r[a]}return!0},s.ensureExists=function(e,t,r){return c(e,t,r,!0)},s.set=function(e,t,r,n){return c(e,t,r,n)},s.insert=function(e,t,r,n){var i=s.get(e,t);n=~~n,o(i)||(i=[],s.set(e,t,i)),i.splice(n,0,r)},s.empty=function(e,t){var i,u;if(!r(t)&&null!=e&&(i=s.get(e,t))){if("string"==typeof i)return s.set(e,t,"");if(function(e){return"boolean"==typeof e||"[object Boolean]"===n(e)}(i))return s.set(e,t,!1);if("number"==typeof i)return s.set(e,t,0);if(o(i))i.length=0;else{if(!function(e){return"object"==typeof e&&"[object Object]"===n(e)}(i))return s.set(e,t,null);for(u in i)a(i,u)&&delete i[u]}}},s.push=function(e,t){var r=s.get(e,t);o(r)||(r=[],s.set(e,t,r)),r.push.apply(r,Array.prototype.slice.call(arguments,2))},s.coalesce=function(e,t,r){for(var n,o=0,i=t.length;o<i;o++)if(void 0!==(n=s.get(e,t[o])))return n;return r},s.get=function(e,t,r){if("number"==typeof t&&(t=[t]),!t||0===t.length)return e;if(null==e)return r;if("string"==typeof t)return s.get(e,t.split("."),r);var n=i(t[0]),o=u(e,n);return void 0===o?r:1===t.length?o:s.get(e[n],t.slice(1),r)},s.del=function(e,t){if("number"==typeof t&&(t=[t]),null==e)return e;if(r(t))return e;if("string"==typeof t)return s.del(e,t.split("."));var n=i(t[0]);return a(e,n)?1!==t.length?s.del(e[n],t.slice(1)):(o(e)?e.splice(n,1):delete e[n],e):e},s}var a=s();return a.create=s,a.withInheritedProps=s({includeInheritedProps:!0}),a}()}));const Ie=/[|\\{}()[\]^$+*?.-]/g;var ke=e=>{if("string"!=typeof e)throw new TypeError("Expected a string");return e.replace(Ie,"\\$&")};const Re=new Map;function De(e,t){t={caseSensitive:!1,...t};const r=e+JSON.stringify(t);if(Re.has(r))return Re.get(r);const n="!"===e[0];n&&(e=e.slice(1)),e=ke(e).replace(/\\\*/g,".*");const o=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return o.negated=n,Re.set(r,o),o}var Fe=(e,t,r)=>{if(!Array.isArray(e)||!Array.isArray(t))throw new TypeError(`Expected two arrays, got ${typeof e} ${typeof t}`);if(0===t.length)return e;const n="!"===t[0][0];t=t.map(e=>De(e,r));const o=[];for(const r of e){let e=n;for(const n of t)n.test(r)&&(e=!n.negated);e&&o.push(r)}return o};function Pe(e,t,r){return function e(t,r,n,o=!0){const i=Object.prototype.hasOwnProperty;function s(e){return null!=e}function a(e){return"Object"===I(e)}function u(e,t){return t=Ee(t),Array.from(e).filter(e=>!t.some(t=>Fe.isMatch(e,t,{caseSensitive:!0})))}const c=["any","anything","every","everything","all","whatever","whatevs"],f=Array.isArray;if(!s(t))throw new Error("check-types-mini: [THROW_ID_01] First argument is missing!");const l={ignoreKeys:[],ignorePaths:[],acceptArrays:!1,acceptArraysIgnore:[],enforceStrictKeyset:!0,schema:{},msg:"check-types-mini",optsVarName:"opts"};let p;if(p=s(n)&&a(n)?Object.assign({},l,n):Object.assign({},l),s(p.ignoreKeys)&&p.ignoreKeys?p.ignoreKeys=Ee(p.ignoreKeys):p.ignoreKeys=[],s(p.ignorePaths)&&p.ignorePaths?p.ignorePaths=Ee(p.ignorePaths):p.ignorePaths=[],s(p.acceptArraysIgnore)&&p.acceptArraysIgnore?p.acceptArraysIgnore=Ee(p.acceptArraysIgnore):p.acceptArraysIgnore=[],p.msg="string"==typeof p.msg?p.msg.trim():p.msg,":"===p.msg[p.msg.length-1]&&(p.msg=p.msg.slice(0,p.msg.length-1).trim()),p.schema&&(Object.keys(p.schema).forEach(e=>{if(a(p.schema[e])){const t={};M(p.schema[e],(r,n,o)=>{const i=void 0!==n?n:r;return f(i)||a(i)||(t[`${e}.${o.path}`]=i),i}),delete p.schema[e],p.schema=Object.assign(p.schema,t)}}),Object.keys(p.schema).forEach(e=>{f(p.schema[e])||(p.schema[e]=[p.schema[e]]),p.schema[e]=p.schema[e].map(String).map(e=>e.toLowerCase()).map(e=>e.trim())})),s(r)||(r={}),o&&e(p,l,{enforceStrictKeyset:!1},!1),p.enforceStrictKeyset)if(s(p.schema)&&Object.keys(p.schema).length>0){if(0!==u(W(Object.keys(t),Object.keys(r).concat(Object.keys(p.schema))),p.ignoreKeys).length){const e=W(Object.keys(t),Object.keys(r).concat(Object.keys(p.schema)));throw new TypeError(`${p.msg}: ${p.optsVarName}.enforceStrictKeyset is on and the following key${e.length>1?"s":""} ${e.length>1?"are":"is"} not covered by schema and/or reference objects: ${e.join(", ")}`)}}else{if(!(s(r)&&Object.keys(r).length>0))throw new TypeError(`${p.msg}: Both ${p.optsVarName}.schema and reference objects are missing! We don't have anything to match the keys as you requested via opts.enforceStrictKeyset!`);if(0!==u(W(Object.keys(t),Object.keys(r)),p.ignoreKeys).length){const e=W(Object.keys(t),Object.keys(r));throw new TypeError(`${p.msg}: The input object has key${e.length>1?"s":""} which ${e.length>1?"are":"is"} not covered by the reference object: ${e.join(", ")}`)}if(0!==u(W(Object.keys(r),Object.keys(t)),p.ignoreKeys).length){const e=W(Object.keys(r),Object.keys(t));throw new TypeError(`${p.msg}: The reference object has key${e.length>1?"s":""} which ${e.length>1?"are":"is"} not present in the input object: ${e.join(", ")}`)}}const h=[];M(t,(e,n,o)=>{let s=n,u=e;if("array"===o.parentType&&(u=void 0,s=e),f(h)&&h.length&&h.some(e=>o.path.startsWith(e)))return s;if(u&&p.ignoreKeys.some(e=>Fe.isMatch(u,e)))return s;if(p.ignorePaths.some(e=>Fe.isMatch(o.path,e)))return s;const l=!(!a(s)&&!f(s)&&f(o.parent));let y=!1;a(p.schema)&&i.call(p.schema,Ae.get(o.path))&&(y=!0);let g=!1;if(a(r)&&Ae.has(r,Ae.get(o.path))&&(g=!0),p.enforceStrictKeyset&&l&&!y&&!g)throw new TypeError(`${p.msg}: ${p.optsVarName}.${o.path} is neither covered by reference object (second input argument), nor ${p.optsVarName}.schema! To stop this error, turn off ${p.optsVarName}.enforceStrictKeyset or provide some type reference (2nd argument or ${p.optsVarName}.schema).\n\nDebug info:\n\nobj = ${JSON.stringify(t,null,4)}\n\nref = ${JSON.stringify(r,null,4)}\n\ninnerObj = ${JSON.stringify(o,null,4)}\n\nopts = ${JSON.stringify(p,null,4)}\n\ncurrent = ${JSON.stringify(s,null,4)}\n\n`);if(y){const e=Ee(p.schema[o.path]).map(String).map(e=>e.toLowerCase());if(Ae.set(p.schema,o.path,e),Ne(e,c).length)h.push(o.path);else if(!0!==s&&!1!==s&&!e.includes(I(s).toLowerCase())||(!0===s||!1===s)&&!e.includes(String(s))&&!e.includes("boolean")){if(!f(s)||!p.acceptArrays)throw new TypeError(`${p.msg}: ${p.optsVarName}.${o.path} was customised to ${"string"!==I(s)?'"':""}${JSON.stringify(s,null,0)}${"string"!==I(s)?'"':""} (type: ${I(s).toLowerCase()}) which is not among the allowed types in schema (which is equal to ${JSON.stringify(e,null,0)})`);for(let t=0,r=s.length;t<r;t++)if(!e.includes(I(s[t]).toLowerCase()))throw new TypeError(`${p.msg}: ${p.optsVarName}.${o.path}.${t}, the ${t}th element (equal to ${JSON.stringify(s[t],null,0)}) is of a type ${I(s[t]).toLowerCase()}, but only the following are allowed by the ${p.optsVarName}.schema: ${e.join(", ")}`)}}else if(g){const t=Ae.get(r,o.path);if(p.acceptArrays&&f(s)&&!p.acceptArraysIgnore.includes(e)){if(!s.every(t=>I(t).toLowerCase()===I(r[e]).toLowerCase()))throw new TypeError(`${p.msg}: ${p.optsVarName}.${o.path} was customised to be array, but not all of its elements are ${I(r[e]).toLowerCase()}-type`)}else if(I(s)!==I(t))throw new TypeError(`${p.msg}: ${p.optsVarName}.${o.path} was customised to ${"string"===I(s).toLowerCase()?"":'"'}${JSON.stringify(s,null,0)}${"string"===I(s).toLowerCase()?"":'"'} which is not ${I(t).toLowerCase()} but ${I(s).toLowerCase()}`)}return s})}(e,t,r)}Fe.isMatch=(e,t,r)=>{const n=De(t,r),o=n.test(e);return n.negated?!o:o};var We=s((function(e,t){!function(r){function n(e,t){return t instanceof Object||(t={trim:!0}),"number"==typeof e&&!isNaN(e)||(e=(e||"").toString(),"trim"in t&&!t.trim?!/\s/.test(e):!!(e=e.trim())&&!isNaN(e))}e.exports&&(t=e.exports=n),t.isNumeric=n}()})),xe=(We.isNumeric,1/0),He="[object Symbol]",Me=/^\s+|\s+$/g,Je="[\\ud800-\\udfff]",Ce="[\\u0300-\\u036f\\ufe20-\\ufe23\\u20d0-\\u20f0]",Ke="\\ud83c[\\udffb-\\udfff]",Le="[^\\ud800-\\udfff]",Ze="(?:\\ud83c[\\udde6-\\uddff]){2}",qe="[\\ud800-\\udbff][\\udc00-\\udfff]",Ue="(?:"+Ce+"|"+Ke+")"+"?",Ve="[\\ufe0e\\ufe0f]?"+Ue+("(?:\\u200d(?:"+[Le,Ze,qe].join("|")+")[\\ufe0e\\ufe0f]?"+Ue+")*"),Be="(?:"+[Le+Ce+"?",Ce,Ze,qe,Je].join("|")+")",ze=RegExp(Ke+"(?="+Ke+")|"+Be+Ve,"g"),Ge=RegExp("[\\u200d\\ud800-\\udfff\\u0300-\\u036f\\ufe20-\\ufe23\\u20d0-\\u20f0\\ufe0e\\ufe0f]"),Qe="object"==typeof i&&i&&i.Object===Object&&i,Xe="object"==typeof self&&self&&self.Object===Object&&self,Ye=Qe||Xe||Function("return this")();function et(e,t,r){if(t!=t)return function(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}(e,tt,r);for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}function tt(e){return e!=e}function rt(e){return function(e){return Ge.test(e)}(e)?function(e){return e.match(ze)||[]}(e):function(e){return e.split("")}(e)}var nt=Object.prototype.toString,ot=Ye.Symbol,it=ot?ot.prototype:void 0,st=it?it.toString:void 0;function at(e){if("string"==typeof e)return e;if(function(e){return"symbol"==typeof e||function(e){return!!e&&"object"==typeof e}(e)&&nt.call(e)==He}(e))return st?st.call(e):"";var t=e+"";return"0"==t&&1/e==-xe?"-0":t}function ut(e,t,r){var n=e.length;return r=void 0===r?n:r,!t&&r>=n?e:function(e,t,r){var n=-1,o=e.length;t<0&&(t=-t>o?0:o+t),(r=r>o?o:r)<0&&(r+=o),o=t>r?0:r-t>>>0,t>>>=0;for(var i=Array(o);++n<o;)i[n]=e[n+t];return i}(e,t,r)}var ct=function(e,t,r){var n;if((e=null==(n=e)?"":at(n))&&(r||void 0===t))return e.replace(Me,"");if(!e||!(t=at(t)))return e;var o=rt(e),i=rt(t);return ut(o,function(e,t){for(var r=-1,n=e.length;++r<n&&et(t,e[r],0)>-1;);return r}(o,i),function(e,t){for(var r=e.length;r--&&et(t,e[r],0)>-1;);return r}(o,i)+1).join("")};function ft(e,n){let o=!0;const i=[".",",","'"," "];let s;if("string"!=typeof e)throw new TypeError(`string-remove-thousand-separators/remSep(): [THROW_ID_01] Input must be string! Currently it's: ${typeof e}, equal to:\n${JSON.stringify(e,null,4)}`);if(null!=n&&!b(n))throw new TypeError(`string-remove-thousand-separators/remSep(): [THROW_ID_02] Options object must be a plain object! Currently it's: ${typeof n}, equal to:\n${JSON.stringify(n,null,4)}`);const a={removeThousandSeparatorsFromNumbers:!0,padSingleDecimalPlaceNumbers:!0,forceUKStyle:!1},u=Object.assign({},a,n);Pe(u,a,{msg:"string-remove-thousand-separators/remSep(): [THROW_ID_03*]"});const c=ct(e.trim(),'"');if(""===c)return c;const f=new A;for(let e=0,t=c.length;e<t;e++){if(u.removeThousandSeparatorsFromNumbers&&""===c[e].trim()&&f.add(e,e+1),u.removeThousandSeparatorsFromNumbers&&"'"===c[e]&&(f.add(e,e+1),"'"===c[e+1])){o=!1;break}if(i.includes(c[e])){if(void 0!==c[e+1]&&We(c[e+1]))if(void 0!==c[e+2]){if(!We(c[e+2])){o=!1;break}if(void 0!==c[e+3]){if(!We(c[e+3])){o=!1;break}if(void 0!==c[e+4]&&We(c[e+4])){o=!1;break}if(u.removeThousandSeparatorsFromNumbers&&f.add(e,e+1),s){if(c[e]!==s){o=!1;break}}else s=c[e]}else u.removeThousandSeparatorsFromNumbers&&u.forceUKStyle&&","===c[e]&&f.add(e,e+1,".")}else u.forceUKStyle&&","===c[e]&&f.add(e,e+1,"."),u.padSingleDecimalPlaceNumbers&&f.add(e+2,e+2,"0")}else if(!We(c[e])){o=!1;break}}return o&&f.current()?function(e,n,o){let i=0,s=0;if(0===arguments.length)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if("string"!=typeof e)throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(null===n)return e;if(!_(n))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n,null,4)}`);if(o&&"function"!=typeof o)throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof o}, equal to: ${JSON.stringify(o,null,4)}`);_(n)&&(t(n[0],{includeZero:!0})||r(n[0],{includeZero:!0}))&&(t(n[1],{includeZero:!0})||r(n[1],{includeZero:!0}))&&(n=[n]);const a=n.length;let u=0;n.forEach((e,c)=>{if(o&&(i=Math.floor(u/a*10))!==s&&(s=i,o(i)),!_(e))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${c}th element not an array: ${JSON.stringify(e,null,4)}, which is ${typeof e}`);if(!t(e[0],{includeZero:!0})){if(!r(e[0],{includeZero:!0}))throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${c}th element, array [${e[0]},${e[1]}]. That array has first element not an integer, but ${typeof e[0]}, equal to: ${JSON.stringify(e[0],null,4)}. Computer doesn't like this.`);n[c][0]=Number.parseInt(n[c][0],10)}if(!t(e[1],{includeZero:!0})){if(!r(e[1],{includeZero:!0}))throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${c}th element, array [${e[0]},${e[1]}]. That array has second element not an integer, but ${typeof e[1]}, equal to: ${JSON.stringify(e[1],null,4)}. Computer doesn't like this.`);n[c][1]=Number.parseInt(n[c][1],10)}u++});const c=v(n,{progressFn:e=>{o&&(i=10+Math.floor(e/10))!==s&&(s=i,o(i))}}),f=c.length;if(f>0){const t=e.slice(c[f-1][1]);e=c.reduce((t,r,n,a)=>{o&&(i=20+Math.floor(n/f*80))!==s&&(s=i,o(i));const u=0===n?0:a[n-1][1],c=a[n][0];return t+e.slice(u,c)+(function(e){return null!=e}(a[n][2])?a[n][2]:"")},""),e+=t}return e}(c,f.current()):c}return function(t,r){var n=0,o=0,i=[],s=[],a=!1,u=!0;if(void 0!==r&&!b(r))throw new Error("csv-split-easy/split(): [THROW_ID_02] Options object must be a plain object! Currently it's of a type ".concat(e(r)," equal to:\n").concat(JSON.stringify(r,null,4)));var c=Object.assign({},{removeThousandSeparatorsFromNumbers:!0,padSingleDecimalPlaceNumbers:!0,forceUKStyle:!1},r);if("string"!=typeof t)throw new TypeError("csv-split-easy/split(): [THROW_ID_04] input must be string! Currently it's: ".concat(e(t),", equal to: ").concat(JSON.stringify(t,null,4)));if(""===t)return[[""]];for(var f=0,l=(t=t.trim()).length;f<l;f++){if(u&&'"'!==t[f]&&","!==t[f]&&""!==t[f].trim()&&(u=!1),'"'===t[f])if(a&&'"'===t[f+1])f+=1;else if(a){a=!1;var p=t.slice(n,f);""!==p.trim()&&(u=!1);var h=/""/.test(p)?p.replace(/""/g,'"'):ft(p,{removeThousandSeparatorsFromNumbers:c.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:c.padSingleDecimalPlaceNumbers,forceUKStyle:c.forceUKStyle});i.push(h)}else a=!0,n=f+1;else if(a||","!==t[f])if("\n"===t[f]||"\r"===t[f]){if(!o){if(o=f,!a&&'"'!==t[f-1]){var y=t.slice(n,f);""!==y.trim()&&(u=!1),i.push(ft(y,{removeThousandSeparatorsFromNumbers:c.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:c.padSingleDecimalPlaceNumbers,forceUKStyle:c.forceUKStyle}))}u?i=[]:s.push(i),u=!0,i=[]}n=f+1}else o&&(o=0,n=f);else{if('"'!==t[f-1]&&!a){var g=t.slice(n,f);""!==g.trim()&&(u=!1),i.push(ft(g,{removeThousandSeparatorsFromNumbers:c.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:c.padSingleDecimalPlaceNumbers,forceUKStyle:c.forceUKStyle}))}n=f+1,o&&(o=0)}if(f+1===l){if('"'!==t[f]){var d=t.slice(n,f+1);""!==d.trim()&&(u=!1),i.push(ft(d,{removeThousandSeparatorsFromNumbers:c.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:c.padSingleDecimalPlaceNumbers,forceUKStyle:c.forceUKStyle}))}u?i=[]:s.push(i),u=!0}}return 0===s.length?[[""]]:s}}));
